Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/MSSQL

Affected QGIS version:2.18.17 Regression?: No
Operating System: Windows Easy fix?: Yes

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 26401
Description

When using an SQL VIEW from MS SQL SERVER the feature filter does not work because it wrongly composes the
SCHEMA.VIEW as "SCHEMA.VIEW" instead of "SCHEMA"."VIEW"
(no problem with schema "dbo", but with all other schema names)

This relates to the vector layers added through the general "add vector layer" command, because the "add MSSQL spatial layer" does not
work at all with views for another reason. If using that command, QGIS rejects the view as "invalid layer" probably because "exec
sp_pkeys @table_name = N'VIEW_NAME', @table_owner = 'SCHEMA_NAME" does not provide a primary key column.

Primarily, views from MSSQL can be loaded using "add vector layer", but they cannot be filtered because of the wrong double-quoting.

I've added an SQL script to quickly create a sample table and view to reconstruct the problem.
Please note: the problem ONLY occurs when using another schema than DBO, so to test you need another schema, do not use dbo!

History

#1 - 2018-10-02 10:19 PM - Nyall Dawson
- Category changed from Expressions to Data Provider/MSSQL

#2 - 2019-01-21 12:35 AM - Jiirgen Fischer

- Status changed from Open to Feedback

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

#3 - 2019-03-09 03:10 PM - Giovanni Manghi
- Resolution set to end of life
- Status changed from Feedback to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

QGIS 3.4 has recently become our new Long Term Release (LTR) version. This is a major step in our history - a long term release version based on the
massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the

relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the
ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help
you plan your deployment of QGIS into an operational environment.

The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and
administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.
